#define MENUOPENID 1
#define MENUSAVEID 2
#define MENUEXITID 3
#define MENUPROPID 4
#define MENUNEWENEMID 5
#define MENUNEWIMGSET 6
#define MENUNEWMOVEMENT 7
#define MENUNEWLEVEL 8
#define MENUEDITMOVE 9
#define MENUNEWID 10

#define LOADEDOK 0
#define YNNNPROBLEM 1
#define ENDTOOSOON 3
#define BMPNOTFOUND 4

 //movement directions
#define DIR_UP 8
#define DIR_DOWN 2
#define DIR_LEFT 4
#define DIR_RIGHT 6
#define DIR_STOP 5
#define DIR_UPRIGHT 9
#define DIR_DOWNRIGHT 3
#define DIR_DOWNLEFT 1
#define DIR_UPLEFT 7

#define DRAGGING_MODE 1
#define MOVEMENT_MODE 2
#define IMGSIZING_MODE 3

#define NOREALWORD -1

const int CLIPOFFTOP=197;
const int MAXMOVNUMS=40;

struct Headerinfo{
char *message;
char *title;
char *bmppath;
char *BGM;
char *WIN;
char *ONEUP;
char *LOSE;
char *END;
int bonus;
char *YNNN;
};

struct ImgSet{
int x;
int y;
int width;
int height;
int frames;
int ID;
bool alive;
};

struct enemy{
int x;
int y;
int ImgID;
int anirate;
int HP;
int speed;
int programID;
bool alive;
};

struct MovProg{
int movement[75];
int steps[75];
int framestart[75];
int frameend[75];
int numofmovs;
bool alive;
};

  ImgSet ImgSets[15];
  enemy enemies[15];
  MovProg movprogs[15];
  Headerinfo HEADR;
  HINSTANCE maininst;
  RECT workarea;
  WNDCLASS wc;
  WNDCLASS hbc;  //level properties box
  WNDCLASS cne;  //new enemy box
  WNDCLASS eep;  //edit enemy program box
//Main window
  HWND hWnd;
  HWND vertbar;
  HWND horzbar;
  HWND seltext;
  HWND selnum;
  HWND xtext;
  HWND ytext;
  HWND yntext;
  HWND xntext;
  HWND eptext;
  HWND epntext;
  HWND epedit;
  HWND progtext;
  HWND progntext;
  HWND progedit;
  HWND HPtext;
  HWND HPedit;
  HWND speedtext;
  HWND speededit2;
  HWND anirtext;
  HWND aniredit;

  HWND seltext2;
  HWND selnum2;
  HWND xtext2;
  HWND ytext2;
  HWND yntext2;
  HWND xntext2;
  HWND frametext;
  HWND framecombo;

  HWND editprogtext;
  HWND editprogntext;
  HWND numofstepstext;
  HWND numofstepsntext;

//Level Properties Box stuff
  HWND headrbox;
  HWND okbuttn;
  HWND cancelbuttn;
  HWND edit1;
  HWND edit2;
  HWND edit3;
  HWND edit4;
  HWND edit5;
  HWND edit6;
  HWND edit7;
  HWND edit8;
  HWND edit9;
  HWND text1;
  HWND text2;
  HWND text3;
  HWND text4;
  HWND text5;
  HWND text6;
  HWND text7;
  HWND text8;
  HWND text9;

//enemy creation box stuff
  HWND enemybox;
  HWND okbutton;
  HWND cancelbutton;
  HWND imageid;
  HWND progid;
  HWND imgidtext;
  HWND progidtext;
  HWND hpedit;
  HWND hpedittext;
  HWND speededit;
  HWND speededittext;
  HWND anirateedit;
  HWND anirateedittext;


//movement edit box stuff
  HWND moveeditbox;
  HWND IDtext;
  HWND IDcombo;
  HWND curtext;
  HWND curcombo;
  HWND dirtext;
  HWND dircombo;
  HWND stepstext;
  HWND stepsedit;
  HWND framestext;
  HWND framestartcombo;
  HWND frameendcombo;
  HWND donebuttn; 
  HWND delbuttn;
  HWND addmovbuttn;
  HWND addprogbuttn;

//menus stuff
  HMENU menu1;
  HMENU filemenu;
  HMENU levelmenu;
  HMENU enemymenu;
  HMENU movemenu;

  COLORREF color;
  MSG msg;
  OPENFILENAME openfile;
  char *filename;
  HBITMAP thepict;
  HPALETTE *mypal;
  SIZE *size;
  char *directory;
  char *filenamebackup=new char[500];
  bool stuffloaded=false;
  int xpos=0;
  int ypos=0;
  int curenem=0;
  HRGN drawrgn;
  signed int selectenemy=-1;
  signed int selectimage=-1;
  signed int selectprog=-1;
  int editmode=1;
  bool mousedown=false;
  bool flickergreen=true;
  bool creatinglevel=false;
  char *iconvert=new char[20];
  char *iconvert2=new char[20];
  int curmove;
  int prevx;
  int prevy;
  int newy;
  int newx;

  int tempID=0;
  int tempx;
  int tempy;
  int tempmovenum=0;
  int tempdir=0;
  int tempnewdir=0;
  int tempselenem=-1;


HCURSOR arrcursor=LoadCursor(NULL,IDC_ARROW);
HCURSOR sizcursor=LoadCursor(NULL,IDC_SIZENWSE);


//functions
LRESULT WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT hbproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT cneproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT eepproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
HBITMAP LoadDDB(char *name,HDC context,HPALETTE *hPal,SIZE* size);
//LoadDDB(File name, DC to be dependant to, *HPALETTE to fill with palette data,*SIZE to fill size data to);
RECT makrect(int x,int y, int a, int b);
RECT* makrectp(int x,int y, int a, int b);
POINT Point(int x,int y);
void quitting(void);
int readdatfile(char *datfilename);
int savedatfile(char *datfilename);
char *readln(ifstream *input);
signed int readword(char *myline,char *thatline);
char *getdirfromstr(char *fileloc);
void RedrawTheThingy(void);
void CreatePropBox(void);
void CreateNewEnemBox(void);
void MakeEditProgBox(void);

